;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function patch_load_background, state, dummy, RESET=reset, VERBOSE=verbose
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
COMMON image, img, header, N, M, a_dim, Nori, Mori
COMMON background, bg

if KEYWORD_SET(reset) THEN reset=1 ELSE reset=0
if KEYWORD_SET(verbose) then verb=1 else verb=0

bg=readfits(state.par.bg_file, /SILENT)

;if (size(bg))[0] EQ 2 then P=1
if ((size(bg))[0] EQ 3 ) then begin
   if (verb) then a=dialog_message(["Multiple images are not supported", $
                     "in this version of PATCH."],   $
                     dialog_parent=dummy, /ERROR)
   return, 0
endif 
if (n_elements(bg) GT n_elements(img)) then begin
   if (verb) then a=dialog_message(["The background array must be of the ",$
                     "same dimensions of the input image."],$
                     dialog_parent=dummy, /ERROR)
   return, 0
endif
if (n_elements(bg) LT n_elements(img)) then begin
   if (verb) then begin
                                ;ask for zero-padding 
         a=dialog_message(["The background array does not fit the image size,", $
                        "do you want to apply a zero-padding around the image?"], $
                        title="QUESTION", /QUESTION, /DEFAULT_NO, $
                        dialog_parent=dummy)
         if (a EQ 'Yes') then bg = zero_padding(bg, N, M) else return, 0
   endif else begin
                                ;in this case PATCH will apply zero-padding by default
      bg = zero_padding(bg, N, M) 
   endelse
endif

if (reset) then begin
;nothing to do!
endif

;add moment of the array


if (verb) then begin
   info=["filename: "+state.par.bg_file, $
         "size: "+strtrim(N,1)+' x '+strtrim(M,1), $
         "Mean, Variance =     "+strtrim((moment(bg))[0],1)+$
                            ', '+strtrim((moment(bg))[1],1), $
         "Skewness, Kurtosis = "+strtrim((moment(bg))[2],1)+$
                            ', '+strtrim((moment(bg))[3],1)]
   ;show info
   WIDGET_CONTROL, state.id.bg_info, SET_VALUE=info
endif
return, 1
end

